#pragma once

#include "pos.h"
#include "map.h"

template <typename T>
class ATTRIB
{
public:
    ATTRIB(T def);
    ~ATTRIB();

    T		value(POS pos) const;
    void	setValue(POS pos, T value);
    void	clear(T value);
    void	clear() { clear(myDefault); }

protected:
    T		myDefault;
    PTRLIST<MAP *>	myMaps;
    PTRLIST<T *>	myValues;
};

#include "attrib.cpp"
