#pragma once

#include "glbdef.h"
#include "ptrlist.h"

class INTRINSIC_LIST
{
public:
    INTRINSIC_LIST() {}
    ~INTRINSIC_LIST() {}

    bool	set(INTRINSIC_NAMES in);
    bool	setTimed(INTRINSIC_NAMES in, int timer);
    bool	clear(INTRINSIC_NAMES in);
    bool	get(INTRINSIC_NAMES in) const;
    void	clearAll();

    void	heartbeat();
protected:
    struct INTSTRUCT
    {
	INTRINSIC_NAMES in;
	int timer;
    };
    PTRLIST<INTSTRUCT> myIntList;
};
